#Include "windows.bi"
#Include Once "win/gdiplus.bi"

'    GDI+
Using GDIPLUS 

Dim Shared ULONG_PTR_01 As ULONG_PTR '    (token) ,    GdiplusShutdown     GDI+
Dim GDIPLUSSTARTUPINPUT_01 As GDIPLUSSTARTUPINPUT '    GDI+
'   GDI+
GDIPLUSSTARTUPINPUT_01.GdiplusVersion = 1
'  GDI+
If (GdiplusStartup(@ULONG_PTR_01, @GDIPLUSSTARTUPINPUT_01, NULL) <> 0) Then
	Print "FAIL"
EndIf

'   ,    window9
Function Load_imageA(ByVal ImagePath As String) As Any Ptr 
	'    GDI+
	Dim GPIMAGE_01 As GPBITMAP Ptr 
	'        Unicode
	Var blen = (Len(ImagePath)*2)+2
	'    unicode 
	Dim As WString Ptr wbuf
	'    
	wbuf  = Allocate( blen )
	'    Unicode
	MultiByteToWideChar(CP_ACP, 0, ImagePath, -1, wbuf, blen)
	'  
	If (GdipLoadImageFromFile( *wbuf, @GPIMAGE_01) <> 0) Then
		Print "FAIL"
	End If
	'   
	DeAllocate(wbuf)
	'     GDI+
	Return GPIMAGE_01
End Function

Dim As Any Ptr hbmpSource '   GDI+
Dim As BitmapData bitmapData '     
Dim image As Any Ptr '   GFX
Dim pixels As Any Ptr '    GFX
Dim As Rect rect '       GDI+
Dim As Integer w,h '    
Dim As Integer pitch '   FbGfx
'  
hbmpSource=Load_imageA("1.png")
'     ,   
If hbmpSource = 0 Then End
'   
GdipGetImageWidth(hbmpSource,@w)
GdipGetImageHeight(hbmpSource,@h)
'        GDI+
rect = Type(0, 0, w-1, h-1)

'  32-bit  .
ScreenRes 320, 200, 32
'   GFX
image = ImageCreate( w, h )
''     gfx      
ImageInfo( image,,,,pitch,pixels )

'        GDI+
GdipBitmapLockBits(hbmpSource,Cast(Any Ptr,@rect),ImageLockModeRead,PixelFormat32bppARGB,@bitmapData)
'     GDI  GFX
For y As Integer = 0 To h-1
	Dim row As UInteger Ptr = pixels + y * pitch '      
	For x As Integer = 0 To w-1
		row[x] = Cast(Integer Ptr,bitmapData.Scan0)[x+y*w] ' 
	Next
Next
'  
GdipBitmapUnlockBits(hbmpSource,@bitmapData)
'     
Paint (10,10),&hff00ff55
'        
Put (10, 10), image,Alpha
Put (79, 69), image,Alpha
'   GFX
ImageDestroy( image )
'   GDI+
GdipDisposeImage(hbmpSource)
'  GDI+
GdiplusShutdown (ULONG_PTR_01)
Sleep